
FLAGS=-Wall -g -DLINUX -fPIC -O2
CSOBJS=csearch.o exhaustive.o exlukes.o 
GGOBJS=graph_get.o
TGOBJS=tree_get.o
BOBJS=belady.o
DMOBJS=directmap.o
CXXFLAGS=-std=c++0x $(FLAGS)
CFLAGS=$(FLAGS)

all: tree_get graph_get csearch1 belady directmap libcsearch.so m5trace

belady: $(BOBJS)
	$(CXX) -o belady $(BOBJS) $(CXXFLAGS) $(LDFLAGS)

directmap: $(DMOBJS)
	$(CXX) -o directmap $(DMOBJS) $(CXXFLAGS) $(LDFLAGS)

tree_get: $(TGOBJS)
	$(CXX) -o tree_get $(TGOBJS) $(CXXFLAGS) $(LDFLAGS)

graph_get: $(GGOBJS)
	$(CXX) -o graph_get $(GGOBJS) $(CXXFLAGS) $(LDFLAGS)

libcsearch.so: $(CSOBJS)
	$(CXX) -shared -o libcsearch.so $(CSOBJS) $(LDFLAGS) 

csearch1: $(CSOBJS) csmain.o
	$(CXX) -o csearch1 csmain.o $(CXXFLAGS) $(CSOBJS) $(LDFLAGS) -L. 

m5trace:
	$(CXX) -o m5trace m5trace.c $(CXXFLAGS) $(LDFLAGS)

clean:
	rm -f csearch1 $(CSOBJS) $(GGOBJS) graph_get $(TGOBJS) tree_get \
            $(BOBJS) belady $(DMOBJS) directmap csmain.o


